import { useState } from 'react';
import Header from './components/Header'
import Tasks from './components/Tasks'
import AddTask from './components/AddTask'
function App() {
  const [showAddTask, setShowAddTask] = useState(false)
  const [tasks, setTasks] = useState([
    {
      id: 1,
      text: "Harry",
      date: "1/1/1111",
      reminder: true,
    },
    {
      id: 2,
      text: "Potter",
      date: "2/2/1221",
      reminder: false,
    },
  ])
  const addTask = (task) =>{ 
    const id = Math.floor(Math.random() * 10) + 1
    const newTask = { id, ...task }
    setTasks([ ...tasks, newTask])
  }
  const deleteTask = (id) => {
    setTasks(tasks.filter((task) => task.id !== id))
  }
    const toggleReminder = (id) => {
      setTasks(tasks.map((task) => task.id === id ? { ...task, reminder: !task.reminder } : task))
    }
  return (
    <div className="App">
      <Header onAdd={() => setShowAddTask(!showAddTask)} />
      {showAddTask && <AddTask onAdd={addTask}/>}
      {tasks.length > 0 ? (
      <Tasks tasks={tasks} onDelete={deleteTask} onToggle={toggleReminder} />

      ) : (
        'No Tasks to show'
      )}
    </div>
  );
}
export default App;